Subject: Re: [PATCH net] tun: free page on short-frame rejection in tun_xdp_one()

From: Weiming Shi <[email-masked]>
Date: Fri, 22 May 2026 00:44:24 +0800

On 26-05-20 20:58, Willem de Bruijn wrote:
> Dongli Zhang wrote:
> > 
> > 
> > On 2026-05-20 5:05 PM, Willem de Bruijn wrote:
> > > Weiming Shi wrote:
> > >> tun_xdp_one() returns -EINVAL on a frame shorter than ETH_HLEN without
> > >> freeing the page that vhost_net_build_xdp() allocated for it.
> > >> tun_sendmsg() discards that -EINVAL and still returns total_len, so
> > >> vhost_tx_batch() takes the success path and never frees the page; each
> > >> short frame in a batch leaks one page-frag chunk.
> > >>
> > >> A local process that can open /dev/net/tun and /dev/vhost-net can hit
> > >> this path: it attaches a tun/tap device as the vhost-net backend and
> > >> feeds TX descriptors whose length minus the virtio-net header is below
> > >> ETH_HLEN. Each kick leaks the page-frag chunks for that batch, and a
> > >> tight submission loop exhausts host memory and triggers an OOM panic.
> > >> Free the page before returning -EINVAL, matching the XDP-program error
> > >> path in the same function.
> > >>
> > >> Fixes: 049584807f1d ("tun: add missing verification for short frame")
> > >> Reported-by: Xiang Mei <[email-masked]>
> > >> Assisted-by: Claude:claude-opus-4-7
> > >> Signed-off-by: Weiming Shi <[email-masked]>
> > >> ---
> > >>  drivers/net/tun.c | 4 +++-
> > >>  1 file changed, 3 insertions(+), 1 deletion(-)
> > >>
> > >> diff --git a/drivers/net/tun.c b/drivers/net/tun.c
> > >> index b183189f1853..f594360d66d6 100644
> > >> --- a/drivers/net/tun.c
> > >> +++ b/drivers/net/tun.c
> > >> @@ -2394,8 +2394,10 @@ static int tun_xdp_one(struct tun_struct *tun,
> > >>  	bool skb_xdp = false;
> > >>  	struct page *page;
> > >>  
> > >> -	if (unlikely(datasize < ETH_HLEN))
> > >> +	if (unlikely(datasize < ETH_HLEN)) {
> > >> +		put_page(virt_to_head_page(xdp->data));
> > >>  		return -EINVAL;
> > >> +	}
> > > 
> > > Make sense, thanks.
> > > 
> > > The error path from tun_xdp_act does the same. And the default: label
> > > used to too, before a batching optimization was introduced.
> > > 
> > > Is the same then also missing if build_skb fails?
> > > 
> > 
> > I also agree that we may need to handle build_skb() failure.
> 
> Thanks. Fine to defer to a separate patch btw. Either way.
>  
> > In addition, I think we may need this fix for tap_get_user_xdp() as well.
> >
> > Thank you very much!
> > 
> > Dongli Zhang
> 
> 
Hi,

I have sent a patch to fix the same issue  and the patch is under review now. 
Please take a look if you have time, thanks!

https://lore.kernel.org/all/[email-masked]/
https://lore.kernel.org/all/[email-masked]/